diff -r 11a8f1275a38 sys/netinet/tcp_output.c
--- a/sys/netinet/tcp_output.c	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_output.c	Mon Mar 11 02:59:51 2013 +1100
@@ -998,14 +1569,14 @@
 	 * Calculate receive window.  Don't shrink window,
 	 * but avoid silly window syndrome.
 	 */
-	if (recwin < (long)(so->so_rcv.sb_hiwat / 4) &&
-	    recwin < (long)tp->t_maxseg)
-		recwin = 0;
-	if (SEQ_GT(tp->rcv_adv, tp->rcv_nxt) &&
-	    recwin < (long)(tp->rcv_adv - tp->rcv_nxt))
-		recwin = (long)(tp->rcv_adv - tp->rcv_nxt);
-	if (recwin > (long)TCP_MAXWIN << tp->rcv_scale)
-		recwin = (long)TCP_MAXWIN << tp->rcv_scale;
+//	if (recwin < (long)(so->so_rcv.sb_hiwat / 4) &&
+//	    recwin < (long)tp->t_maxseg)
+//		recwin = 0;
+//	if (SEQ_GT(tp->rcv_adv, tp->rcv_nxt) &&
+//	    recwin < (long)(tp->rcv_adv - tp->rcv_nxt))
+//		recwin = (long)(tp->rcv_adv - tp->rcv_nxt);
+//	if (recwin > (long)TCP_MAXWIN << tp->rcv_scale)
+//		recwin = (long)TCP_MAXWIN << tp->rcv_scale;
 
 	/*
 	 * According to RFC1323 the window field in a SYN (i.e., a <SYN>
@@ -1013,8 +1584,9 @@
 	 * case is handled in syncache.
 	 */
 	if (flags & TH_SYN)
-		th->th_win = htons((u_short)
-				(min(sbspace(&so->so_rcv), TCP_MAXWIN)));
+		th->th_win = htons(TCP_MAXWIN);
+//		th->th_win = htons((u_short)
+//				(min(sbspace(&so->so_rcv), TCP_MAXWIN)));
 	else
 		th->th_win = htons((u_short)(recwin >> tp->rcv_scale));
 
@@ -1056,6 +1628,7 @@
 	 * checksum extended header and data.
 	 */
 	m->m_pkthdr.len = hdrlen + len; /* in6_cksum() need this */
+	m->m_pkthdr.csum_flags = CSUM_TCP;
 	m->m_pkthdr.csum_data = offsetof(struct tcphdr, th_sum);
 #ifdef INET6
 	if (isipv6) {
@@ -1292,7 +1865,6 @@
 				tp->snd_nxt -= len;
 		}
 out:
-		SOCKBUF_UNLOCK_ASSERT(&so->so_snd);	/* Check gotos. */
 		switch (error) {
 		case EPERM:
 			tp->t_softerror = error;
@@ -1359,6 +1931,7 @@
 #endif
 	if (sendalot)
 		goto again;
+
 	return (0);
 }
 
@@ -1481,6 +2054,15 @@
 				 *optp++ = 0;
 			break;
 			}
+		case TOF_MPTCP:
+			{
+			while (optlen % 2) {
+				optlen += TCPOLEN_NOP;
+				*optp++ = TCPOPT_NOP;
+			}
+			mp_addoptions(to, &optlen, optp);
+			break;
+			}
 		case TOF_SACK:
 			{
 			int sackblks = 0;
diff -r 11a8f1275a38 sys/netinet/tcp_reass.c
--- a/sys/netinet/tcp_reass.c	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_reass.c	Mon Mar 11 02:59:51 2013 +1100
@@ -68,6 +68,8 @@
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp_var.h>
+
 #include <netinet6/tcp6_var.h>
 #include <netinet/tcpip.h>
 #ifdef TCPDEBUG
@@ -77,6 +79,11 @@
 static int tcp_reass_sysctl_maxseg(SYSCTL_HANDLER_ARGS);
 static int tcp_reass_sysctl_qsize(SYSCTL_HANDLER_ARGS);
 
+#define TAILQ_FOREACH_CONTINUE(var, head, field)                        \
+        for ((var) = ((var) ? (var) : TAILQ_FIRST((head)));             \
+        (var);                                                          \
+        (var) = TAILQ_NEXT((var), field))
+
 static SYSCTL_NODE(_net_inet_tcp, OID_AUTO, reass, CTLFLAG_RW, 0,
     "TCP Segment Reassembly Queue");
 
@@ -143,13 +150,14 @@
 
 	INP_WLOCK_ASSERT(tp->t_inpcb);
 
-	while ((qe = LIST_FIRST(&tp->t_segq)) != NULL) {
-		LIST_REMOVE(qe, tqe_q);
+	while ((qe = TAILQ_FIRST(tp->t_segq)) != NULL) {
+		TAILQ_REMOVE(tp->t_segq, qe, tqe_q);
 		m_freem(qe->tqe_m);
 		uma_zfree(V_tcp_reass_zone, qe);
 		tp->t_segqlen--;
 	}
 
+	tp->t_segqlen = 0;
 	KASSERT((tp->t_segqlen == 0),
 	    ("TCP reass queue %p segment count is %d instead of 0 after flush.",
 	    tp, tp->t_segqlen));
@@ -169,6 +177,13 @@
 	return (sysctl_handle_int(oidp, arg1, arg2, req));
 }
 
+void
+tcp_reass_release_element(struct tseg_qent *q)
+{
+	uma_zfree(V_tcp_reass_zone, q);
+}
+
+
 int
 tcp_reass(struct tcpcb *tp, struct tcphdr *th, int *tlenp, struct mbuf *m)
 {
@@ -180,9 +195,14 @@
 	char *s = NULL;
 	int flags;
 	struct tseg_qent tqs;
+	struct mpcb *mp = tp->t_mpcb;
 
 	INP_WLOCK_ASSERT(tp->t_inpcb);
 
+	flags = 0;
+
+	SF_REASS_RLOCK(mp);
+
 	/*
 	 * XXX: tcp_reass() is rather inefficient with its data structures
 	 * and should be rewritten (see NetBSD for optimizations).
@@ -192,8 +212,12 @@
 	 * Call with th==NULL after become established to
 	 * force pre-ESTABLISHED data up to user socket.
 	 */
-	if (th == NULL)
-		goto present;
+	if (th == NULL) {
+		if(TAILQ_EMPTY(tp->t_segq))
+			goto unlock_return;
+		else
+			goto present;
+	}
 
 	/*
 	 * Limit the number of segments that can be queued to reduce the
@@ -211,19 +235,21 @@
 	 * Investigate why and re-evaluate the below limit after the behaviour
 	 * is understood.
 	 */
-	if (th->th_seq != tp->rcv_nxt &&
-	    tp->t_segqlen >= (so->so_rcv.sb_hiwat / tp->t_maxseg) + 1) {
-		V_tcp_reass_overflows++;
-		TCPSTAT_INC(tcps_rcvmemdrop);
-		m_freem(m);
-		*tlenp = 0;
-		if ((s = tcp_log_addrs(&tp->t_inpcb->inp_inc, th, NULL, NULL))) {
-			log(LOG_DEBUG, "%s; %s: queue limit reached, "
-			    "segment dropped\n", s, __func__);
-			free(s, M_TCPLOG);
-		}
-		return (0);
-	}
+
+	/* XXXNJW: Need to revisit this in re to receive window advertising */
+//	if (th->th_seq != tp->rcv_nxt &&
+//	    tp->t_segqlen >= (so->so_rcv.sb_hiwat / tp->t_maxseg) + 1) {
+//		V_tcp_reass_overflows++;
+//		TCPSTAT_INC(tcps_rcvmemdrop);
+//		m_freem(m);
+//		*tlenp = 0;
+//		if ((s = tcp_log_addrs(&tp->t_inpcb->inp_inc, th, NULL, NULL))) {
+//			log(LOG_DEBUG, "%s; %s: queue limit reached, "
+//			    "segment dropped\n", s, __func__);
+//			free(s, M_TCPLOG);
+//		}
+//		goto unlock_return;
+//	}
 
 	/*
 	 * Allocate a new queue entry. If we can't, or hit the zone limit
@@ -244,7 +270,7 @@
 				    "reached, segment dropped\n", s, __func__);
 				free(s, M_TCPLOG);
 			}
-			return (0);
+			goto unlock_return;
 		} else {
 			bzero(&tqs, sizeof(struct tseg_qent));
 			te = &tqs;
@@ -260,9 +286,23 @@
 	tp->t_segqlen++;
 
 	/*
+	 * 'fastpath' check
+	 */
+	if (th->th_seq == tp->rcv_nxt && !tp->t_segq->disordered) {
+		p = TAILQ_LAST(tp->t_segq, sf_reass_queue_head);
+		goto fastpath;
+	}
+
+	/*
+	 * setting to te is temp until we know exactly where
+	 * disorder starts
+	 */
+	tp->t_segq->disordered = te;
+
+	/*
 	 * Find a segment which begins after this one does.
 	 */
-	LIST_FOREACH(q, &tp->t_segq, tqe_q) {
+	TAILQ_FOREACH(q, tp->t_segq, tqe_q) {
 		if (SEQ_GT(q->tqe_th->th_seq, th->th_seq))
 			break;
 		p = q;
@@ -285,12 +325,10 @@
 				uma_zfree(V_tcp_reass_zone, te);
 				tp->t_segqlen--;
 				/*
-				 * Try to present any queued data
-				 * at the left window edge to the user.
-				 * This is needed after the 3-WHS
-				 * completes.
+				 * Already have data in queue that this segment provided.
+				 * Queue is still disordered, return and send a DUP ACK
 				 */
-				goto present;	/* ??? */
+				goto unlock_return;
 			}
 			m_adj(m, i);
 			*tlenp -= i;
@@ -315,54 +353,223 @@
 			m_adj(q->tqe_m, i);
 			break;
 		}
-
-		nq = LIST_NEXT(q, tqe_q);
-		LIST_REMOVE(q, tqe_q);
+		nq = TAILQ_NEXT(q, tqe_q);
+		TAILQ_REMOVE(tp->t_segq, q, tqe_q);
 		m_freem(q->tqe_m);
 		uma_zfree(V_tcp_reass_zone, q);
 		tp->t_segqlen--;
 		q = nq;
 	}
 
+fastpath:
 	/* Insert the new segment queue entry into place. */
 	te->tqe_m = m;
 	te->tqe_th = th;
 	te->tqe_len = *tlenp;
+	te->tqe_dsn = 0; // XXX: Can there be a legitimate 0 DSN?
+
+	if (te->tqe_len > 0) {
+		struct m_tag *mtag =  m_tag_locate(m, PACKET_COOKIE_MPTCP,
+			PACKET_TAG_DSN, NULL);
+		KASSERT(mtag != NULL, ("%s segment of len %d is missing an mbuf tag\n",
+			__func__, te->tqe_len));
+		te->tqe_dsn = ((struct dsn_tag *)mtag)->dsn;
+	}
 
 	if (p == NULL) {
-		LIST_INSERT_HEAD(&tp->t_segq, te, tqe_q);
+		/* Queue is empty so insert at head. */
+		TAILQ_INSERT_HEAD(tp->t_segq, te, tqe_q);
+		if (th->th_seq == tp->rcv_nxt)
+			tp->t_segq->disordered = NULL;
 	} else {
+		/* Otherwise put it in sequence order in queue. */
 		KASSERT(te != &tqs, ("%s: temporary stack based entry not "
 		    "first element in queue", __func__));
-		LIST_INSERT_AFTER(p, te, tqe_q);
+		TAILQ_INSERT_AFTER(tp->t_segq, p, te, tqe_q);
+
+		if (te == TAILQ_LAST(tp->t_segq, sf_reass_queue_head)) {
+			if(th->th_seq == tp->rcv_nxt) //inserted rcv_nxt at end of queue
+				tp->t_segq->disordered = NULL;
+		} else {
+			/*
+			 * Search from segment just inserted towards end of list looking
+			 * for a hole.
+			 */
+			q = te;
+			TAILQ_FOREACH_CONTINUE(q, tp->t_segq, tqe_q) {
+				nq = TAILQ_NEXT(q, tqe_q);
+				if (nq != NULL &&
+				    q->tqe_th->th_seq + q->tqe_len != nq->tqe_th->th_seq) {
+					/* Found the first out of sequence segment in the reass list. */
+					tp->t_segq->disordered = nq;
+					break;
+				}
+			}
+			if (q == NULL)
+				tp->t_segq->disordered = NULL;
+		}
 	}
 
 present:
 	/*
 	 * Present data to user, advancing rcv_nxt through
 	 * completed sequence space.
+	 *
+	 * If connection not established then return.
+	 *
+	 * If the queue is empty, or the first element is not the next expected,
+	 * then return.
 	 */
-	if (!TCPS_HAVEESTABLISHED(tp->t_state))
-		return (0);
-	q = LIST_FIRST(&tp->t_segq);
-	if (!q || q->tqe_th->th_seq != tp->rcv_nxt)
-		return (0);
+	if (!TCPS_HAVEESTABLISHED(tp->t_state)) {
+		goto unlock_return;
+	}
+
+	if(mp->direct_map)
+		mp->ds_rcv_nxt = tp->rcv_nxt;
+
+	/*
+	 * If there is some amount of in-order data we know that rcv_nxt
+	 * can be set to the sequence number of the highest byte received.
+	 * If the previous element to the first disordered segment is NULL,
+	 * it means we have no in-order data.
+	 */
+	if (tp->t_segq->disordered) {
+		nq = TAILQ_PREV(tp->t_segq->disordered, sf_reass_queue_head, tqe_q);
+		if (nq != NULL)
+			tp->rcv_nxt = nq->tqe_th->th_seq + nq->tqe_len;
+		else
+			goto unlock_return;	// in this else the first element of the list is disordered, return immediately
+
+	} else {
+		nq = TAILQ_LAST(tp->t_segq, sf_reass_queue_head);
+		tp->rcv_nxt = nq->tqe_th->th_seq + nq->tqe_len;
+		/*
+		 * if the last segment in the list has a FIN and we are not disordered
+		 * indicate to tcp_input that a FIN has been delivered.
+		 */
+		flags = nq->tqe_th->th_flags & TH_FIN;
+	}
+
+	/* is this segment next in data sequence order? */
+	q = TAILQ_FIRST(tp->t_segq);
+
+	KASSERT(q->tqe_dsn >= tp->t_mpcb->ds_rcv_nxt || q->tqe_th->th_flags & TH_FIN,
+	    ("%s: Segment DSN %ju less than ds_rcv_nxt %ju\n", __func__,
+	    (uintmax_t)q->tqe_dsn,
+	    (uintmax_t)tp->t_mpcb->ds_rcv_nxt));
+
+	// XXXNJW: be careful about reading ds_rcv_nxt
+	if ((mp->direct_map && (q->tqe_th->th_seq + q->tqe_len != tp->rcv_nxt))
+	    || (!mp->direct_map && q->tqe_dsn != tp->t_mpcb->ds_rcv_nxt)) {
+		goto unlock_return;
+	}
+
+	SF_REASS_RUNLOCK(mp);
+
+	/*
+	 * XXXNJW: This is a temporary hack to allow upcalls that
+	 * require a certain number of bytes (sb_cc) before calling
+	 * soreceive() to work with deferred reassembly. In these
+	 * cases reassembly occurs in the subflow context rather than
+	 * in the context of the receiving process.
+	 */
 	SOCKBUF_LOCK(&so->so_rcv);
-	do {
-		tp->rcv_nxt += q->tqe_len;
-		flags = q->tqe_th->th_flags & TH_FIN;
-		nq = LIST_NEXT(q, tqe_q);
-		LIST_REMOVE(q, tqe_q);
-		if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
-			m_freem(q->tqe_m);
-		else
-			sbappendstream_locked(&so->so_rcv, q->tqe_m);
-		if (q != &tqs)
-			uma_zfree(V_tcp_reass_zone, q);
-		tp->t_segqlen--;
-		q = nq;
-	} while (q && q->tqe_th->th_seq == tp->rcv_nxt);
+	//if (so->so_rcv.sb_upcall != NULL)
+		mp_do_reass(so);
+
+	//XXXNJW: Does this belong here or in do_reass context?
 	ND6_HINT(tp);
 	sorwakeup_locked(so);
+
+	return (flags);
+
+unlock_return:
+	SF_REASS_RUNLOCK(mp);
 	return (flags);
 }
+
+void
+mp_do_reass(struct socket *so) {
+
+//error = m_mbuftouio(uio, sb->sb_mb, len);
+
+	/* XXX this is where we walk the subflow lists looking for
+	 * a segment matching dss rcv_nxt (there will always be at
+	 * least one in here before sorwakeup is called).
+	 * as we find in-sequence segments, pass them up to wherever,
+	 * then take the segment out of the list and release the mbuf.
+	 *
+	 * could cheat and call appendstream here?
+	 */
+	struct tcpcb *tp = sototcpcb(so); //= ((struct tcpcb *)(ip)->inp_ppcb);
+	struct mpcb *mp;
+	struct tseg_qent *nq = NULL;
+	struct tseg_qent *q = NULL;
+	struct sockbuf *sb;
+
+	sb = &so->so_rcv;
+
+	SOCKBUF_LOCK_ASSERT(sb);
+
+	if (!tp)
+		return;
+
+	mp = tp->t_mpcb;
+	KASSERT(mp != NULL,("%s: No mp control block for TCP flow\n", __func__));
+
+	/*
+	 * Search through subflow lists for in-order segments. if
+	 * found, remove from the list, append to sb and release
+	 * the mbuf
+	 *
+	 * XXXNJW this is inefficient when there are lots of subflows
+	 */
+	SF_REASS_WLOCK(mp);
+
+	struct tcpcb *subflow_tp = NULL;
+start_reass_head_list:
+	SLIST_FOREACH(subflow_tp, &mp->tp_list, next_subflow) {
+		q = TAILQ_FIRST(subflow_tp->t_segq);
+		if (!q)
+			continue;
+
+		if (q->tqe_dsn == mp->ds_rcv_nxt) {
+			KASSERT(!subflow_tp->t_segq->disordered,
+					("%s Subflow out of order but first element is at ds_rcv_nxt\n", __func__));
+			do {
+				mp->ds_rcv_nxt += q->tqe_len;
+				nq = TAILQ_NEXT(q, tqe_q);
+				TAILQ_REMOVE(subflow_tp->t_segq, q, tqe_q);
+				if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
+					m_freem(q->tqe_m);
+				else
+					sbappendstream_locked(&so->so_rcv, q->tqe_m);
+				uma_zfree(V_tcp_reass_zone, q);
+					subflow_tp->t_segqlen--;
+				q = nq;
+			} while (q && q->tqe_dsn == mp->ds_rcv_nxt && q != subflow_tp->t_segq->disordered);
+			goto start_reass_head_list;
+		} else if ((q->tqe_len == 0 &&
+		    (q->tqe_th->th_flags & TH_FIN) && !tp->t_segq->disordered)
+		    || q->tqe_dsn < mp->ds_rcv_nxt) {
+			TAILQ_REMOVE(subflow_tp->t_segq, q, tqe_q);
+			uma_zfree(V_tcp_reass_zone, q);
+			subflow_tp->t_segqlen--;
+			/* XXX: In the q->tqe_dsn < mp->ds_rcv_nxt case, ideally want to
+			 * continue from the next element in the current list, rather than
+			 * from the first element in the first list. */
+			goto start_reass_head_list;
+		}
+	}
+
+	SF_REASS_WUNLOCK(mp);
+
+	/*
+	 * Schedule a data level ACK. (currently this just sends the
+	 * ACK on the next outbound packet on any subflow
+	 */
+	if (!tp->t_mpcb->direct_map)
+		tp->t_mpcb->mp_flags |= MPO_DATA_ACK;		//XXXNJW move to the point where we have read in the data
+
+}
+
diff -r 11a8f1275a38 sys/netinet/tcp_sack.c
--- a/sys/netinet/tcp_sack.c	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_sack.c	Mon Mar 11 02:59:51 2013 +1100
@@ -114,6 +114,7 @@
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp_var.h>
 #include <netinet6/tcp6_var.h>
 #include <netinet/tcpip.h>
 #ifdef TCPDEBUG
diff -r 11a8f1275a38 sys/netinet/tcp_subr.c
--- a/sys/netinet/tcp_subr.c	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_subr.c	Mon Mar 11 02:59:51 2013 +1100
@@ -45,6 +45,7 @@
 #include <sys/kernel.h>
 #include <sys/khelp.h>
 #include <sys/sysctl.h>
+#include <sys/taskqueue.h>
 #include <sys/jail.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
@@ -53,6 +54,7 @@
 #endif
 #include <sys/priv.h>
 #include <sys/proc.h>
+#include <sys/queue.h>
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/protosw.h>
@@ -89,6 +91,8 @@
 #include <netinet6/tcp6_var.h>
 #endif
 #include <netinet/tcpip.h>
+#include <netinet/mptcp_var.h>
+#include <crypto/sha1.h>
 #ifdef TCPDEBUG
 #include <netinet/tcp_debug.h>
 #endif
@@ -114,6 +118,10 @@
 
 #include <security/mac/mac_framework.h>
 
+/* for malloc'ing list heads */
+MALLOC_DECLARE(M_REASSLISTHEAD);
+MALLOC_DEFINE(M_REASSLISTHEAD, "reasshead", "Head of reass queue list");
+
 VNET_DEFINE(int, tcp_mssdflt) = TCP_MSS;
 #ifdef INET6
 VNET_DEFINE(int, tcp_v6mssdflt) = TCP6_MSS;
@@ -251,6 +259,13 @@
 	struct	osd		osd;
 };
 
+struct mppcb_mem {
+	struct	mpcb		mpcb;
+};
+
+static VNET_DEFINE(uma_zone_t, mpcb_zone);
+#define	V_mpcb_zone			VNET(mpcb_zone)
+
 static VNET_DEFINE(uma_zone_t, tcpcb_zone);
 #define	V_tcpcb_zone			VNET(tcpcb_zone)
 
@@ -311,6 +326,10 @@
 	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
 	uma_zone_set_max(V_tcpcb_zone, maxsockets);
 
+	V_mpcb_zone = uma_zcreate("mpcb", sizeof(struct mppcb_mem),
+				    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
+		uma_zone_set_max(V_mpcb_zone, maxsockets);
+
 	tcp_tw_init();
 	syncache_init();
 	tcp_hc_init();
@@ -341,6 +360,8 @@
 	TUNABLE_INT_FETCH("net.inet.tcp.soreceive_stream", &tcp_soreceive_stream);
 	if (tcp_soreceive_stream) {
 #ifdef INET
+		tcp_usrreqs.pru_soreceive = soreceive_mpstream;
+#else
 		tcp_usrreqs.pru_soreceive = soreceive_stream;
 #endif
 #ifdef INET6
@@ -668,6 +689,7 @@
 {
 	struct tcpcb_mem *tm;
 	struct tcpcb *tp;
+
 #ifdef INET6
 	int isipv6 = (inp->inp_vflag & INP_IPV6) != 0;
 #endif /* INET6 */
@@ -726,6 +748,21 @@
 		tp->t_flags |= TF_SACK_PERMIT;
 	TAILQ_INIT(&tp->snd_holes);
 	tp->t_inpcb = inp;	/* XXX */
+
+	/* insert head of list of reass queue heads */
+	tp->t_segq = malloc(sizeof(struct sf_reass_queue_head),
+			M_REASSLISTHEAD, M_NOWAIT | M_ZERO);
+
+	/*
+	 * pointer to the reassembly list head, which is inside the
+	 * sf_reass_queues_list (i.e. the list of reassembly queues
+	 */
+	TAILQ_INIT(tp->t_segq);
+
+	/* dss map queue */
+	TAILQ_INIT(&tp->t_txdsmaps);
+	TAILQ_INIT(&tp->t_rxdsmaps);
+
 	/*
 	 * Init srtt to TCPTV_SRTTBASE (0), so we can tell that we have no
 	 * rtt estimate.  Set rttvar so that srtt + 4 * rttvar gives
@@ -748,6 +785,131 @@
 	return (tp);		/* XXX */
 }
 
+
+struct mpcb *
+mp_newmpcb(struct inpcb *inp)
+{
+	struct mppcb_mem *mpm;
+	struct mpcb *mp;
+
+	mpm = uma_zalloc(V_mpcb_zone, M_NOWAIT | M_ZERO);
+	if (mpm == NULL)
+		return (NULL);
+	mp = &mpm->mpcb;
+	mp->master_inpcb = inp;
+	mp->master_socket = inp->inp_socket;
+	mp->subflow_cnt = 1;
+	mp->laddr_mask = 0;
+	mp->raddr_mask = 0;
+
+	mp->mp_state = MPS_CLOSED;
+	mp->direct_map = 1;
+	mp->mp_flags = 0;
+
+	/* Init list of subflow tpcbs */
+	SLIST_INIT(&mp->tp_list);
+
+	/* List of subflow segment lists */
+	STAILQ_INIT(&mp->sf_reass_queues_list);
+
+	/* List of subflow send lists */
+	TAILQ_INIT(&mp->mp_ds_sndmaps);
+
+	/* Init task handling for asynchronous sending of MP_JOINs */
+	TASK_INIT(&mp->join_task, 0, mp_join_task_handler, mp);
+
+	TASK_INIT(&mp->data_task, 0, mp_datascheduler_task_handler, mp);
+
+	/*
+	 * Set the masks. We clear bits as ADD_ADDRs and JOINS are sent
+	 * for each of the  slave-subflows.
+	 */
+	uint32_t bitmask = 0xffffffff;
+	mp->mp_advjoin_mask = mp->mp_advaddr_mask = ~(bitmask << mp_address_count);
+
+	/*
+	 * init the REASS lock. used for:
+	 * sf_reass_queues_list: when user process does reassembly
+	 * t_segq: when segments are inserted into the reassembly list
+	 */
+	SF_REASS_LOCK_INIT(mp);
+
+	/* insert endpoint id of first subflow into local address array */
+	/* use addressID of 0 for the master subflow? */
+	//mp_add_local_addr(mp, (struct in_addr *) &inp->inp_laddr, inp->inp_lport, 0);
+	return (mp);		/* XXX */
+
+}
+
+/*
+ * Free everything. locks, lists etc etc
+ *
+ */
+void
+mp_discardcb(struct mpcb *mp)
+{
+	/* XXXNJW: as we dont remove slave subflows from the list as we
+	 * end them this following check doesn't work. As the master subflow
+	 * is last in the list this should only be called once all the other
+	 * subflows are finished.
+	 */
+//	KASSERT(SLIST_NEXT(SLIST_FIRST(&mp->tp_list), next_subflow) == NULL,
+//	   ("%s: Freeing master tp while slave subflows exist\n", __func__));
+
+
+    struct ds_map *map, *map_next;
+    map = TAILQ_FIRST(&mp->mp_ds_sndmaps);
+    while (map != NULL) {
+            map_next = TAILQ_NEXT(map, mp_ds_map_next);
+            free(map, M_DSSMAP);
+            map = map_next;
+    }
+
+    struct sf_reass_queue_head *q_h, *nq_h;
+    q_h = STAILQ_FIRST(&mp->sf_reass_queues_list);
+	while (q_h != NULL) {
+		nq_h = STAILQ_NEXT(q_h, tqe_next_head);
+		/* reass queue elements flushed in tcp_discardcb */
+		free(q_h, M_REASSLISTHEAD);
+		q_h = nq_h;
+	}
+
+	SF_REASS_LOCK_DESTROY(mp);
+	uma_zfree(V_mpcb_zone, mp);
+
+}
+
+// XXXNJW: To be inlined, renamed
+void
+tcp_ackmap(struct tcpcb *tp, struct tcphdr *th)
+{
+	struct ds_map *map;
+	int completed_a_map = 0;
+
+	do {
+		map = TAILQ_LAST(&tp->t_txdsmaps, dsmapq_head);
+		if (map != NULL && th->th_ack >= (map->sf_seq_start + map->ds_map_len)) {
+			KASSERT(map->flags & MAPF_IS_SENT, ("map %p acked but not marked as sent", map));
+//			mp_debug(DSMAP, 4, "%s: Marked snd_dsmap %p as ACKED, map_len: %d, mbuf_start: %p, sf_seq_start: %u\n",
+//				__func__, map, map->ds_map_len, map->mbuf_start, map->sf_seq_start);
+			/* This ack cumulatively acks all bytes outstanding in this map. */
+			TAILQ_REMOVE(&tp->t_txdsmaps, map, sf_ds_map_next);
+			/* Must come after TAILQ_REMOVE so mp_deferred_sbdrop can't trash the link. */
+			map->flags |= MAPF_IS_ACKED;
+			completed_a_map++;
+			if (tp->t_mpcb->direct_map && map->ds_map_start == tp->t_mpcb->ds_snd_una) {
+				tp->t_mpcb->ds_snd_una += map->ds_map_len;
+			}
+		} else
+			map = NULL; // TAILQ empty or no more maps in the list are covered by this ack
+	} while (map != NULL);
+
+	if (tp->t_mpcb->direct_map && completed_a_map) {
+//		printf("%s: header ACK num %u\n", __func__, th->th_ack);
+		mp_deferred_sbdrop(tp->t_mpcb);
+	}
+}
+
 /*
  * Switch the congestion control algorithm back to NewReno for any active
  * control blocks using an algorithm which is about to go away.
@@ -941,6 +1103,9 @@
 
 	khelp_destroy_osd(tp->osd);
 
+	if (tp->t_mpcb != NULL && IS_MASTER_TP(tp))
+		mp_discardcb(tp->t_mpcb);
+
 	CC_ALGO(tp) = NULL;
 	inp->inp_ppcb = NULL;
 	tp->t_inpcb = NULL;
